import { Component } from '@angular/core';
import { HttpClient } from '@angular/common/http'
import { Data } from './interface'
import { Router,ActivatedRoute } from '@angular/router'
import {CacheTokenService} from './http-interceptors/cache-token.service'//引入服务



@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent {

  constructor(private http:HttpClient,private router:Router,public token:CacheTokenService) { }

  ngOnInit(): void {
    var token = sessionStorage.getItem("token");
    var refreshToken = sessionStorage.getItem("refreshToken");
    if(token && refreshToken) {
      this.http.post('/api/Account/RefreshToken', {
        token: token,
        refreshToken: refreshToken
      }).subscribe((data: Data) => {
        sessionStorage.setItem("level",data.level);
        sessionStorage.setItem("token",data.token);
        sessionStorage.setItem("refreshToken",data.refreshToken);
        this.token.startUp()
      })
    } 

  }



}
