import { HttpClient } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { DateAdapter } from '@angular/material/core';
import { MatDialog } from '@angular/material/dialog';
import { MatSnackBar, MatSnackBarConfig } from '@angular/material/snack-bar';
import { Router } from '@angular/router';
import { CacheTokenService } from 'src/app/http-interceptors/cache-token.service';

@Component({
  selector: 'app-home',
  templateUrl: './home.component.html',
  styleUrls: ['./home.component.scss']
})
export class HomeComponent implements OnInit {

  constructor(private http:HttpClient,public token:CacheTokenService,public dialog: MatDialog,private router:Router,public snackBar: MatSnackBar,private adapter: DateAdapter<any>,) { }

  ngOnInit(): void {
    this.adapter.setLocale('CH');
    this.enddate = new FormControl(new Date()); //日历结束时间显示
  }

  enddate:any; //查询时间
  tableData :any = [
    {target: '梧州市金龙万豪酒店', time: '2020-10-29 07:19', leadTheTeam: '郑子墨', updateStaff: '赵竹林', },
    {target: '众美光合原筑', time: '2020-11-02 07:19', leadTheTeam: '何先超', updateStaff: '何晨', },
    {target: '凡尔赛公馆', time: '2020-11-02 11:19', leadTheTeam: '吴洁丽', updateStaff: '赵玉', },
    {target: '西黄岛九号', time: '2020-11-03 07:19', leadTheTeam: '吴毅溪', updateStaff: '赵晓慧', },
    {target: '首城双景', time: '2020-11-07 07:19', leadTheTeam: '周伟林', updateStaff: '李英顺', },
    {target: '华贸国际公馆', time: '2020-11-11 07:19', leadTheTeam: '李林颖', updateStaff: '吴思怡', },
    {target: '鸿威翡翠城', time: '2020-11-12 07:19', leadTheTeam: '李双杆', updateStaff: '钱浩宇', },
    {target: '泽信公馆', time: '2020-11-14 11:19', leadTheTeam: '孙正荣', updateStaff: '孙正云', },
    {target: '润泽御府', time: '2020-11-17 07:19', leadTheTeam: '赵虎林', updateStaff: '冯燕', },
    {target: '万达广场', time: '2020-11-20 07:19', leadTheTeam: '周伟林', updateStaff: '李英顺', },
    {target: '天悦', time: '2020-11-22 07:19', leadTheTeam: '冯燕', updateStaff: '冯靖宇', },
  ]

  //退出系统
  signOut () {
    let out = confirm("您确定要退出吗")
    if(out) {
      this.http.post('/api/Account/SignOut',{}).subscribe(data=> {
        this.token.delete()
        sessionStorage.clear()
        window.localStorage.clear()
        this.router.navigate(['/login'])
        const config = new MatSnackBarConfig();
        config.verticalPosition = 'bottom';
        config.duration = 3000
        this.snackBar.open('成功退出','确定',config);
      })
    }
  }

  //查询
  query () {
    console.log('查询')
  }

  //新增
  add () {
    this.router.navigate([`/addsixfamiliar`])
  }

  //查看详情
  viewDetails () {
    localStorage.setItem("pattern","look")
    this.router.navigate([`/trainingrecordinfo`],{queryParams:{'id':'5eabd9ce8f12f09a6a24f53e'}})
    console.log('查看详情')
  }



}
